%{!?kernel_version: %{expand: %%define kernel_version %(uname -r| perl -pe 's/-[a-zA-Z].*?$//g')}}
%{!?kversionreltag: %{expand: %%define kversionreltag %(echo %{kernel_version} |sed -e 's/-/./g')}}
%{!?type: %{expand: %%define type %(uname -r| perl -pe 's/.*-//g')}}

%define releasetag %{kversionreltag}.%{type}
%define kernel_dir %{kernel_version}-%{type}
%define kmp_version %version

# Keep the modKey def identical to that in util.sh-PMWV.*
%define modKey 'PMWV|%{type}|vmblock'
%define vmwDB /usr/lib/vmware-tools/moduleScripts/vmblock/vmware-db.pl --os=linux,sle,9
%define vmwPMWV /usr/lib/vmware-tools/moduleScripts/vmblock/vmware-pmwv.pl --os=linux,sle,9 --release=%{kernel_dir} --build 2791197 --modKey %{modKey}

Name:         vmware-tools-vmblock
BuildRequires: kernel-source kernel-syms
Requires:     vmware-tools-vmblock-common
Requires:     vmware-tools-foundation >= 0:8.6.0
Provides:     vmware-tools-vmblock-kmp
Vendor:       VMware
License:      GPL
Group:        System/Kernel
Summary:      The vmblock kernel module built for the %{kernel_version} kernel.
Epoch:        0
Version:      1.1.2.0
Release:      %{kversionreltag}.5.sles9
BuildRoot:    %{_tmppath}/%{name}-%{version}-build


Source0:      vmblock.tar

%prep
%setup -n vmblock-only

%build
make clean
make

# NOTE: RHEL 4 has MODVERSIONS enabled but does not generate the module.symvers
#       file we would need in order to properly propagate symbol versions
#       in-between interdependent kernel modules.  See bug 568405 for more info.
if [ "vmblock" = "vsock" -o "vmblock" = "vmhgfs" ]; then
   echo
   echo
   echo "Please ignore the \"VMCI_ ... undefined!\" warnings generated by the build system."
   echo "The vmblock module will load and function properly despite those warnings."
   echo
   echo
fi

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
install -m 644 -D ../vmblock.o $RPM_BUILD_ROOT/lib/modules/%{kernel_dir}/extra/vmware/vmblock.ko

%package kmp-%{type}
Summary:      The vmblock kernel module built for the %{kernel_version} kernel.
Group:        System/Kernel
Requires:     vmware-tools-vmblock-common
Requires:     vmware-tools-foundation >= 0:8.6.0
Provides:     vmware-tools-vmblock-kmp
Release:      %{kversionreltag}.5.sles9
Requires: vmware-tools-core >= %{?epoch:%{epoch}:}8.6.0

%description kmp-%{type}
 This package contains a pre-compiled vmblock module for use with the %{kernel_version} kernel.   The vmblock module is used by vmware-user to block file access to files that are in the process of being copied from host to guest or guest to host (such as a drag and drop operation between a host and a guest).

%description
 This package enables you to build binary kernel module packages (kmps) for vmblock.  The vmblock module is used by vmware-user to block file access to files that are in the process of being copied from host to guest or guest to host (such as a drag and drop operation between a host and a guest).

%pre kmp-%{type}
# Deconfigure if upgrading
if [ $1 -gt 1 ]; then
   kmodType=`uname -r | sed -e 's/.*-//g'`
   if [ "$kmodType" = "%{type}" ]; then
      /etc/init.d/vmblock stop || true
   fi

   %{vmwPMWV} --rpmSection=Postun
fi

# Configure
%{vmwPMWV} --rpmSection=Pre

%post kmp-%{type}
# Configure
# Invoke the PMWV Post Section
%{vmwPMWV} --rpmSection=Post --baseMod=/lib/modules/%{kernel_dir}/extra/vmware/vmblock.ko

# If the type matches, start the init script
kmodType=`uname -r | sed -e 's/.*-//g'`
if [ "$kmodType" = "%{type}" ]; then
   /etc/init.d/vmblock start || true
fi

%preun kmp-%{type}
# Only deconfigure if we are erasing the package here... not if we are upgrading.
if [ $1 = 0 ]; then
   kmodType=`uname -r | sed -e 's/.*-//g'`
   if [ "$kmodType" = "%{type}" ]; then
      /etc/init.d/vmblock stop || true
   fi
fi

%postun kmp-%{type}
# Only deconfigure if we are erasing the package here... not if we are upgrading.
if [ $1 = 0 ]; then
   %{vmwPMWV} --rpmSection=Postun
fi

%files kmp-%{type}
%defattr(-, root, root, -)
/lib/modules/%{kernel_dir}/extra/vmware/vmblock.ko
